ghc-7.0.3: The GHC API

Pretty

# Documentation

data Doc

Instances

Show Doc |

data Mode

Constructors

PageMode |
ZigZagMode |
LeftMode |
OneLineMode |

data TextDetails

Constructors

Chr !Char |
Str String |
PStr FastString |
LStr !LitString FastInt |

empty :: Doc

isEmpty :: Doc -> Bool

nest :: Int -> Doc -> Doc

char :: Char -> Doc

text :: String -> Doc

ftext :: FastString -> Doc

ptext :: LitString -> Doc

int :: Int -> Doc

integer :: Integer -> Doc

float :: Float -> Doc

double :: Double -> Doc

rational :: Rational -> Doc

parens :: Doc -> Doc

brackets :: Doc -> Doc

braces :: Doc -> Doc

quotes :: Doc -> Doc

doubleQuotes :: Doc -> Doc

semi :: Doc

comma :: Doc

colon :: Doc

space :: Doc

equals :: Doc

lparen :: Doc

rparen :: Doc

lbrack :: Doc

rbrack :: Doc

lbrace :: Doc

rbrace :: Doc

cparen :: Bool -> Doc -> Doc

(<>) :: Doc -> Doc -> Doc

(<+>) :: Doc -> Doc -> Doc

hcat :: [Doc] -> Doc

hsep :: [Doc] -> Doc

($$) :: Doc -> Doc -> Doc

($+$) :: Doc -> Doc -> Doc

vcat :: [Doc] -> Doc

sep :: [Doc] -> Doc

cat :: [Doc] -> Doc

fsep :: [Doc] -> Doc

fcat :: [Doc] -> Doc

hang :: Doc -> Int -> Doc -> Doc

punctuate :: Doc -> [Doc] -> [Doc]

render :: Doc -> String

fullRender :: Mode -> Int -> Float -> (TextDetails -> a -> a) -> a -> Doc -> a

printDoc :: Mode -> Handle -> Doc -> IO ()

showDocWith :: Mode -> Doc -> String

bufLeftRender :: BufHandle -> Doc -> IO ()